jQuery(document).ready(function() {
	var carousels = jQuery('.slick-carousel');

	function carouselData(index, context) {
		var item			= index,
			activeItem		= jQuery(context).find('[data-slick-index="' + item + '"]'),
			inactiveItems	= jQuery(context).find('.item').not(activeItem),
			caption			= activeItem.find('.rstpl-caption'),
			data			= {
				caption         	: caption,
				inactiveCaptions	: jQuery(inactiveItems).find('.rstpl-caption')
			};

		if (activeItem.prev().length) {
			data['prevImg'] = activeItem.prev().find('.rstpl-slider-main-image').css('background-image').replace(/.*\s?url\([\'\"]?/, '').replace(/[\'\"]?\).*/, '');
		}

		if (activeItem.next().length) {
			data['nextImg'] = activeItem.next().find('.rstpl-slider-main-image').css('background-image').replace(/.*\s?url\([\'\"]?/, '').replace(/[\'\"]?\).*/, '');
		}

		return data;
	}

	function randomAnimation() {
		var animations = [
			// fades
			"fadeIn",
			"fadeInUp",
			"fadeInDown",
			"fadeInRight",
			"fadeInLeft",
			// bounces
			"bounceIn",
			"bounceInUp",
			"bounceInDown",
			"bounceInRight",
			"bounceInLeft",
			// zooms
			"zoomIn",
			"zoomInUp",
			"zoomInDown",
			"zoomInRight",
			"zoomInLeft",
			// specials
			"lightSpeedIn",
			"flipInX",
			"flipInY"
		];

		return animations[Math.floor(Math.random() * animations.length)];
	}


	carousels.each(function () {
		jQuery(this).on('init', function (slick) {
			// Init Skrollr
			if (jQuery(this).hasClass('parallax-enabled')) {
				skrollr.init({
					mobileCheck	: function () {
						//hack - forces mobile version to be off
						return false;
					},
					forceHeight	: false
				});
			}

			var $currentItem		= jQuery(this).find('.slick-current'),
				$currentItemIndex	= parseInt($currentItem.attr('data-slick-index'));

			if (!jQuery(this).hasClass('instagram-slider')) {
				var data = carouselData($currentItemIndex, this);

				jQuery('.rstpl-car-previous').append('<div class="prev-img"></div>');

				if ((typeof data.prevImg != 'undefined')) {
					jQuery('.rstpl-car-previous .prev-img').css('background-image', 'url(' + data.prevImg + ')')
				}

				jQuery('.rstpl-car-next').append('<div class="next-img"></div>');

				if ((typeof data.nextImg != 'undefined')) {
					jQuery('.rstpl-car-next .next-img').css('background-image', 'url(' + data.nextImg + ')')
				}

				jQuery(data.caption).find('h2, p, a').each(function () {
					var animation = jQuery(this).attr('data-animation');

					if (animation == 'random') {
						jQuery(this).addClass(randomAnimation()).css('opacity', 1);
					} else {
						jQuery(this).addClass(animation).css('opacity', 1);
					}

				});
			}
		});

		jQuery(this).on('beforeChange', function (slick, currentSlide, nextSlide) {

			var $currentItem		= jQuery(this).find('.slick-current'),
				$currentItemIndex	= parseInt($currentItem.attr('data-slick-index'));

			if (!jQuery(this).hasClass('instagram-slider')) {
				data = carouselData($currentItemIndex, this);

				jQuery(data.inactiveCaptions).find('h2, p, a').each(function () {
					var animation = jQuery(this).attr('data-animation');

					if (animation == 'random') {
						var self	= jQuery(this),
							classes	= jQuery(this).attr("class").split(' ');

						jQuery.each(classes, function (i, c) {
							if (c.indexOf("fade") === 0 || c.indexOf("bounce") === 0 || c.indexOf("zoom") === 0 || c.indexOf("flip") === 0 || c.indexOf("light") === 0) {
								jQuery(self).removeClass(c).css('opacity', 0);
							}
						});

					} else {
						jQuery(this).removeClass(animation).css('opacity', 0);
					}
				});
			}
		});

		jQuery(this).on('afterChange', function (slick, currentSlide) {
			var $currentItem		= jQuery(this).find('.slick-current'),
				$currentItemIndex	= parseInt($currentItem.attr('data-slick-index'));

			if (!jQuery(this).hasClass('instagram-slider')) {
				data = carouselData($currentItemIndex, this);
				
				if ((typeof data.prevImg != 'undefined')) {
					jQuery('.prev-img').css('background-image', 'url(' + data.prevImg + ')');
				} else {
					jQuery('.prev-img').css('background-image', '');
				}

				if ((typeof data.nextImg != 'undefined')) {
					jQuery('.next-img').css('background-image', 'url(' + data.nextImg + ')');
				}
				else {
					jQuery('.next-img').css('background-image', '');
				}

				jQuery(data.caption).find('h2, p, a').each(function () {
					var animation = jQuery(this).attr('data-animation');

					if (animation == 'random') {
						jQuery(this).addClass(randomAnimation()).css('opacity', 1);
					} else {
						jQuery(this).addClass(animation).css('opacity', 1);
					}
				});
			}
		});
	});
});

